int nodeCount;//頂点の総数
int ex_nodeCount;//画面に表示されるキャラが何体いるか
Node[] nodes;//頂点自体のデータ集合
int flag;//掴んでいるノードの番号
int pause_c;//ポーズ中のフレーム数を記録
int semitra;//アイコンの透明度semitransparent
PFont font; // フォント
boolean pmousePressed;//前フレームでマウスが押されていたか
boolean anc_f;//画面下部のバーを掴んでいるかどうかのフラグ。trueなら掴んでいる、falseなら掴んでいない。
float SwiX=440;//バーの位置
//PImage sam=loadImage("16×16詰め合わせ/reimu16.png");
float repul;//斥力の大きさ
float v=0.8;//速度の元栓
int bor=20;//画面端
int bor_u=20;//下の画面端
int bor_a=61;//上の画面端
int t_s=14;//テキストのサイズ
int i_v_li;//アイコンの移動制限速度
int ctrl;//ユーザの操作に対する扱いを決める変数。-1なら操作を受け付けない。0ならクリックのみ受け付ける。1ならアイコンを動かせる。
int tuto;//今チュートリアルモードであるどうか、どのチュートリアルを実行しているかのフラグ。-1ならチュートリアルでない。2なら最初の質問へ。
int tuto_si;//チュートリアル内の進捗状況を示す変数
int icon_fr=0;//アイコンを掴んだときの円のエフェクトの大きさを管理する変数
boolean icon_f=false;//直前のフレームで円のエフェクトを表示したかどうか
int f_que=-1;//最初にチュートリアルを見か選ぶ場面で、マウスがどの選択肢の上に乗ってるか。-1なら乗ってない。0なら「見る！」、1なら「じゃあいいです」に乗っている
int f_q_ti=0;//チュートリアル表示時にアイコンが動く範囲を設定する値。
boolean flag_sukima=false;//スキマの上でクリックしたかどうかのフラグ。
int pick_num=-1;//最近掴んでいたアイコンの番号。
int f_tu=0;//チュートリアル中でのフレーム経過数。
//フリーズする原因は、壁際でまったく同じ座標にアイコンが複数存在するフレームがあり、そのアイコン同士でatanを計算できないからと推測される。
//と思ったが違った。原因がわからない。同じところにアイコンを集めるとフリーズする確率が高い気がする。

boolean stop=false;//アイコンの動きが止まっているかどうか。trueなら止まっている。falseなら止まってない。
int f_count=0;//フレーム数。プレイヤーの操作で止められる
int c_x,c_y;//時計アイコンの位置（アイコンの中央の座標）
int c_b;//時計アイコンの大きさ（半径）
//PImage clock=loadImage("pic_without_chara/tokei02.png");//時計アイコン画像
//PImage clock_pin=loadImage("pic_without_chara/tokeihari01.gif");//時計の針アイコン画像
PImage clock=loadImage("pic_without_chara/path4005.png");//時計アイコン画像
PImage clock_pin=loadImage("pic_without_chara/g5305.png");//時計の針アイコン画像

void setup() {
    nodeCount=10;
    size(600, 600); 
    nodes = new Node[100];
    loadData(); // データの読み込み
    frameRate (10);
    t_s=14;
    font = createFont("SansSerif", t_s);
    textFont("SansSerif", t_s);  
    //smooth(); // 辺の描画を滑らかに
    flag=-1;
    stopping=false;
    pause_c=0;
    semitra=255;
    c_x=130;
    c_y=30;
    c_b=30;
    //ctrl=1;//関数setupで設定したこの変数は上書きできなくなった（processing.jsのバグ？）
    //tuto=0;
    //tuto_s=0;
    //fileName[2] = "16.png";;
}


//stroke(randomRGBColor());
//ellipse(0,0,100,100);

class Node{//人物のアイコンのクラス
 float num;//アイコンの番号
 float ex_num;//表示されてるアイコン中の番号
 float hue;//アイコンの色相
 float x,y;//アイコンのx,y座標
 float sx,sy;//アイコンがスキマ内にある場合、現状での位置
 float o_sx,o_sy;//スキマ内のアイコンがあるべき位置
 float dx, dy; // アイコンのx,y変位
 float farDis = 150.0, nearDis = 0.0;//斥力が作用する最大および最小の距離
 float[] con;//他の人物とのつながりの強さ
 string name;//アイコンが指す人物の名前
 string full_name;//アイコンが指す人物のフルネーム
 boolean exist;//アイコンの存在。Falseなら存在しないものとして扱える。
 boolean f_own=false;//掴まれているかどうか
 PImage dot;//キャラのドット絵
 int[] rank;//このキャラのツイート中での他キャラの出現順位をランク付けしたもの
 boolean s_export=false;//スキマを出ようとしている状態かどうか。出ようとしてるならtrue,してないならfalse
 boolean s_inport=false;//スキマに入ろうとしている状態かどうか。入ろうとしてるならtrue,してないならfalse
 boolean s_move=false;//スキマ内で動いている状態かどうか。動いているならtrue,動いてないならfalse

 Node(string n,float[] c,PImage d,boolean exi,int nu,int[] ra,string f){//コンストラクタ
  x=int(random(width));
  y=int(random(height));
  //x=30+random(5);
  //y=70+random(5);
  name=n;
  con=c;
  dot=d;
  exist=exi;
  num=nu;
  rank=ra;
  full_name=f;
  sx=int(random(width));
  sy=int(random(height));
  o_sx=0;
  o_sy=0;
  /*dx=random(10);
  dy=random(10);*/
 }

 void force () { // 頂点同士が近づきすぎるのを回避
    //println(x);
    float ddx = ddy = 0; // 合力の x,y 軸成分
    for (int j = 0; j < nodeCount; j++) {
      Node n = nodes[j];
      if (n != this && n.exist==true) { // 自分自身を除外する
            float d = mag (x - n.x, y - n.y);//magは距離
            if (d < farDis && d > nearDis) { // 近接した場合に斥力が働く 
                d=constrain(d, 0.01, 1000);
                //float f = 0.1 / d;//ここの数字で斥力の大きさが決まる
                float f = v*repul / d;//ここの数字で斥力の大きさが決まる
                ddx += f * (x - n.x); // 合力の計算
                ddy += f * (y - n.y);
            }
      }
    }
    dx += ddx; // 反発力の成分を変位量に追加する
    dy += ddy;
 }

 void s_force () { // ばねにより、辺を自然長に近づける
    //float sp=0.0004;//ばねの固さ（絆の強さ）
    int len=25;//ばねの自然長
    float ddx = ddy = 0; // 合力の x,y 軸成分
    for (int j = 0; j < nodeCount; j++) {
      Node n = nodes[j];
      if (n != this && n.exist==true) { // 自分自身を除外する
            float d = mag (x - n.x, y - n.y);//magは距離
            //float f = sp * (d - len); // バネ力の計算
            float f = v*con[j]*con[j] * (d - len); // バネ力の計算
            ddx -= f * (x - n.x)/d; // 合力の計算
            ddy -= f * (y - n.y)/d;
      }
    }
    dx += ddx; // 反発力の成分を変位量に追加する
    dy += ddy;
 }

  void wall(){//壁からの反発力を加える
    //float w = textWidth(con[0]);
    e_m=-0.5;//弾性係数(?)
    cnst=1;//加える速度の定数
    if (x-6<=bor && dx<0){
        dx=dx*e_m;
    }
    if (x+6>=width-bor && dx>0){
        dx=dx*e_m;
    }
    if (y-6<=bor_a && dy<0){
        dy=dy*e_m;
    }
    if (y+6>= height-bor_u && dy>0){
        dy=dy*e_m;
    }
  }

 void show_cone(){//アイコン同志の間に線を引く
    colorMode(HSB,255);
//    float hue=255*num/nodeCount;

    //float hue=255*ex_num/ex_nodeCount;
    int pul=30;
    float magni=frameCount%pul;
    for (int j = 0; j < nodeCount; j++) {
      Node n = nodes[j];
      if (n != this && n.exist==true) { // 自分自身を除外する
       //if (con[j]>0.03){
       if (con[j]>(SwiX-230)/5000 && mag (x - n.x, y - n.y)!=0){
        dep=constrain((1-((SwiX-230)/(con[j]*5000)))*3, 0, 1);
        stroke(hue, 255, 192,(255-ex_nodeCount*2)*dep);
        int tri_mag=200*con[j];//三角形の大きさ
        float ang=atan2(n.y-y,n.x-x);
        ang_no=PI/2+ang;
        float sl_x=cos(ang_no)*12;//slはスリップ
        float sl_y=sin(ang_no)*12;
        float a_si_x=cos(ang)*tri_mag/2;//矢印の大きさに応じた調整
        float a_si_y=sin(ang)*tri_mag/2;
        float arrow_x=(n.x-x)*(magni/pul)+x+sl_x+a_si_x;
        float arrow_y=(n.y-y)*(magni/pul)+y+sl_y+a_si_y;
        float tri_ang=9*PI/10;
        /*strokeWeight (4);
        fill(hue,255,128,50*ts/magni);
        stroke(hue,s,v,255*ts/magni);*/
        strokeWeight (1);
        fill(hue,128,255,128);
        triangle(arrow_x, arrow_y, arrow_x+cos(ang+tri_ang)*tri_mag, arrow_y+sin(ang+tri_ang)*tri_mag, arrow_x+cos(ang-tri_ang)*tri_mag, arrow_y+sin(ang-tri_ang)*tri_mag);
        //ellipse((n.x-x)*magni/pul+x+sl_x, (n.y-y)*magni/pul+y+sl_y, 4, 4);
        strokeWeight(con[j]*50);
        //strokeWeight(con[j]*(SwiY-150)/500);
        line(x+sl_x,y+sl_y,n.x+sl_x,n.y+sl_y);
       }
      }
    }
 }

 void update(){//アイコンの位置の更新
  //noFill();
  if (s_inport==true){
    if (mag(sukima_p.y-y,sukima_p.x-x)<=50){
     x=sukima_p.x;
     y=sukima_p.y;
    }else{
     float ang=atan2(sukima_p.y-y,sukima_p.x-x);
     x+=cos(ang)*50;
     y+=sin(ang)*50;
    }
  }else{
    v_d=0.94;//点の速度の落ち方
    v_bd=constrain(i_v_li, 0, 80); //v_border(点が動く制限速度)
    x += constrain(dx, -1*v_bd, v_bd); 
    y += constrain(dy, -1*v_bd, v_bd);
    x = constrain(x, bor, width-bor); // ウインドウ内部に制限する
    y = constrain(y, bor_a, height-bor_u);
    //dx = dy = 0;
    dx = v_d*constrain(dx, -1*v_bd, v_bd); // 速度が振り切れないように制限
    dy = v_d*constrain(dy, -1*v_bd, v_bd);
    //rect (x, y, 20, 20);
  }
 }

 void s_update(){//スキマ内でのアイコン位置の更新
    if (mag(o_sy-sy,o_sx-sx)<=50){
     sx=o_sx;
     sy=o_sy;
     s_move=false;
    }else{
     float ang=atan2(o_sy-sy,o_sx-sx);
     sx+=cos(ang)*50;
     sy+=sin(ang)*50;
     s_move=true;
    }
 }

 void show(){//アイコンとキャラ名の表示
    size=dot.width;
    image(dot,x-size/2,y-size/2);
    font = createFont("SansSerif", t_s);

    fill(#000000);
    font = createFont("SansSerif", t_s*1.2);
    float w = textWidth(name);
    text(name, x-(w/2), y-10);
 }

 void show(float pos_x,float pos_y,float size,float gap){//アイコンとキャラ名を、場所と大きさを指定して表示
    fill(#000000);
    w_size=1.2;
    font = createFont("SansSerif", t_s*w_size);
    float w = textWidth(name);
    while(w>=gap){
     w_size-=0.1;
     font = createFont("SansSerif", t_s*w_size);
     float w = textWidth(name);
    }
    text(name, pos_x-(w/2), pos_y-size/2-4);
    image(dot,pos_x-size/2,pos_y-size/2,size,size);
    font = createFont("SansSerif", t_s);
 }

  boolean check(){//このアイコンにマウスが載っているかどうかを判定し返す。
    if (mag(x-mouseX,y-mouseY)<=18 && exist==true){
      return true;
      }else{
      return false;
      }
  }

  boolean s_check(){//スキマ内のアイコンにマウスが載っているかどうかを判定し返す。
    if (mag(sx-mouseX,sy-mouseY)<=18){
      return true;
      }else{
      return false;
      }
  }

  boolean check_sukima(){//このアイコンとスキマが近いかどうかを判定し返す。
    if (mag(x-sukima_p.x,y-sukima_p.y)<=32){
      return true;
      }else{
      return false;
      }
  }

  boolean check_sukima_inc(){//このアイコンのスキマ内座標とスキマが近いかどうかを判定し返す。
    if (mag(sx-sukima_p.x,sy-sukima_p.y)<=32){
      return true;
      }else{
      return false;
      }
  }

  void i_export(){//アイコンがスキマから出る処理
      o_sx=sukima_p.x;
      o_sy=sukima_p.y;
      s_export=true;
  }

  void pos(){//アイコンをマウスのある位置に持ってくる
    dx=constrain(mouseX, bor, width-bor)-x;
    dy=constrain(mouseY, bor_a, height-bor_u)-y;
    f_own=true;
  }

  void icon_eff(){//アイコンを掴んだときのエフェクト
    int min_size=6;
    int pul=15;
    int plus_size=5;
    int ts=3.5;//透明度倍率
    int s=255;//彩度
    int v=255;//明るさ
    //float magni=sqrt(frameCount%pul);//倍率
    float magni=icon_fr%pul;//倍率
    //float hue=255*num/nodeCount;
    fill(hue,s,v,50-(ts*magni));
    stroke(hue,s,v,255-(ts*5*magni));
    strokeWeight (4);
    ellipse(x, y, min_size+magni*plus_size, min_size+magni*plus_size);
    //tint(255, 255*wei/si);
    //image(dot,x-si/2,y-si/2,si,si);//画像を半透明にすると処理が重くなるので、エフェクトにドット絵を使うのは断念
    //tint(255, 255);
    icon_f=true;
  }

  void icon_arc(){//該当キャラについての円グラフを表示。
    float total=0.0;
    float pres=0.0;//現在値
    int arc_x=3*width/4;//円グラフの位置
    int arc_y=height/4;//円グラフの位置
    int t_di=70;//円グラフに表示する名前が中心から離れている距離
    int cir=240;//円グラフ半径
    fill(0,0,0,128);
    stroke(0,0,0,0);
    float w = textWidth(full_name);
    float b_x = constrain(3*width/5-w, 0, width/2); 
    rect(b_x,0,2*width/3,height/2+t_s*2);
    //boolean flag=false;//ループ内で同じ値を見つけたか
    for (int j = 0; j < nodeCount; j++){//絆の合計値を計算
     Node n = nodes[j];
     if (n.exist==true)
      total=float(con[j])+total;//con[j]を文字列として見てるようだ
    }
    total=total-float(con[num]);//自分自身の分はカウントしない。
    if (total!=0){
     for (int j = 0; j < nodeCount; j++) {//キャラ順序を決めるプログラムの出力値が1多い（だからグラフに「霊夢」が出ない）
     //pres=0;
      Node n = nodes[rank[j]];
      if (n.exist==true & n.num!=num){
//      if (n.exist==true){
         colorMode(HSB,255);
         //float hue=255*n.num/nodeCount;
         strokeWeight (4);
         fill(n.hue,128,255,100);
         stroke(n.hue,128,255,255);
        //strokeWeight(con[j]*10);
        //line(x,y,n.x,n.y);
         //arc(x+50,y+50,50,50,2*PI*pres/total,2*PI*((pres+con[rank[j]])/total));
         if (float(con[rank[j]])/total>=0.03){
          if (float(con[rank[j]])/total<=0.04){
           textFont("SansSerif", 11);
          }
          float deg=2*PI*((pres+float(con[rank[j]])/2)/total);
          arc(arc_x,arc_y,cir,cir,2*PI*pres/total,2*PI*((pres+float(con[rank[j]]))/total));//最後二つの値が同じだとフリーズするので注意
          stroke(0,0,0,255);
          strokeWeight (0.5);
          line(arc_x,arc_y,arc_x+cir/2*cos(2*PI*pres/total),arc_y+cir/2*sin(2*PI*pres/total));
          //fill(hue,128,128,255);
          fill(0,0,255,255);
          String[] name_num = new Sring[4];//キャラ名と割合の配列
          if (deg<=PI/2 || deg>=PI*3/2){
           name_num[3] = n.name;
           name_num[2] = " ";
           name_num[0] = str(nf(100*float(con[rank[j]])/total, 1, 1));
           name_num[1] = "%";
           String name_num_j =join(name_num,"");
           float w = textWidth(name_num_j);
           ro=deg;
           tx=arc_x+(t_di-w/2)*cos(deg);
           ty=arc_y+(t_di-w/2)*sin(deg);
          }else{
           name_num[0] = n.name;
           name_num[1] = "　";
           name_num[2] = str(nf(100*float(con[rank[j]])/total, 1, 1));
           name_num[3] = "%";
           String name_num_j =join(name_num,"");
           float w = textWidth(name_num_j);
           ro=deg+PI;
           tx=arc_x+(t_di+w/2)*cos(deg);
           ty=arc_y+(t_di+w/2)*sin(deg);
          }
          translate(tx,ty);
          rotate(ro);
          text(name_num_j, 0,t_s/3);
          rotate(-ro);
          translate(-tx,-ty);
          pres+=float(con[rank[j]]);
         }

         //flag=true;
      }
     }
     if (abs(pres-total)>0.0001){//「その他」があるかどうかの判定。
          if ((1-pres/total)<=0.04){
           textFont("SansSerif", 11);
          }else{
           textFont("SansSerif", t_s);
          }
          strokeWeight (4);
          fill(0,0,0,100);
          stroke(0,0,0,255);
          float deg=2*PI*(((pres+total)/2)/total);
          arc(arc_x,arc_y,cir,cir,2*PI*pres/total,2*PI);//最後二つの値が同じだとフリーズするので注意
          stroke(0,0,0,255);
          strokeWeight (0.5);
          line(arc_x,arc_y,arc_x+cir/2*cos(2*PI*pres/total),arc_y+cir/2*sin(2*PI*pres/total));
          fill(0,0,255,255);
          String[] name_num = new Sring[3];//"その他"と割合の配列
          if (deg<=PI/2 || deg>=PI*3/2){
           name_num[2] = " その他";
           name_num[0] = str(nf(100*(1-pres/total), 1, 1));
           name_num[1] = "%";
           String name_num_j =join(name_num,"");
           float w = textWidth(name_num_j);
           ro=deg;
           tx=arc_x+(t_di-w/2)*cos(deg);
           ty=arc_y+(t_di-w/2)*sin(deg);
          }else{
           name_num[0] = "その他 ";
           name_num[1] = str(nf(100*(1-pres/total), 1, 1));
           name_num[2] = "%";
           String name_num_j =join(name_num,"");
           float w = textWidth(name_num_j);
           ro=deg+PI;
           tx=arc_x+(t_di+w/2)*cos(deg);
           ty=arc_y+(t_di+w/2)*sin(deg);
          }
          translate(tx,ty);
          rotate(ro);
          text(name_num_j, 0,t_s/3);
          rotate(-ro);
          translate(-tx,-ty);
     }
    }
    fill(0,0,255,255);
    textFont("SansSerif", t_s*1.8);  
    float w = textWidth(full_name);
    text(full_name, 13*width/20-w/2,height/2);
    textFont("SansSerif", t_s);
    text('の関係シェア', 13*width/20-w/2,height/2+t_s*1.5);
    image(dot,9*width/10,4*height/9,48,48);

    textFont("SansSerif", t_s);
  }
}

class Sukima{//スキマのアイコンのクラス
 float x,y;//スキマのx,y座標
 int state;//今、スキマをどう利用できるかを示すフラグ。0ならアイコンをスキマにドラッグすることでスキマ内に入れられる。1ならアイコンをクリックするとスキマ内に入る。2ならアイコンをクリックするとスキマからアイコンが出てくる。trueならできる。falseならできない。
 PImage dot;//スキマのドット絵
 PImage dot_out;//スキマから矢印が出て行くドット絵
 PImage dot_in;//スキマに矢印が入るドット絵
 int anim_count;//スキマにアイコンが入ってから何フレーム経過したか。

 Sukima(int in_x,int in_y,boolean in_s,PImage in_d,PImage in_d_in,PImage in_d_out){//コンストラクタ
  x=in_x;
  y=in_y;
  s_state=in_s;
  dot=in_d;
  dot_out=in_d_out;
  dot_in=in_d_in;
  anim_count=100;
 }

 void show(){//アイコンの表示
    image(dot,x-32,y-32,60,60);
 }

 void show_in(){//スキマにキャラを入れる状態のアイコンを表示
    //magni=0.02*constrain(anim_count, 0, 100);
    //image(dot_in,x-(32*magni),y-(32*magni),107*magni,104*magni);
    image(dot_in,x-32,y-32,107,104);
 }

 void show_out(){//スキマからキャラを出す状態のアイコンを表示
    image(dot_out,x-32,y-32,110,108);
 }

 void show_cont(){//スキマ内にいるキャラの表示
  fill(0,0,0,64);
  stroke(0,0,0,0);
  rect(0,0,width,height);

  int uni=54;//アイコン同士の間隔
  int pos_x=uni/2;
  int pos_y=uni*2.5;
  for (int j = 0; j<nodeCount;j++){
   if (nodes[j].exist==false){
    nodes[j].show(nodes[j].sx,nodes[j].sy,32,uni);
    if (nodes[j].s_export==false){
     nodes[j].o_sx=pos_x;
     nodes[j].o_sy=pos_y;
     pos_x+=uni;
     if (pos_x+uni/2>=width){
      pos_x=uni/2;
      pos_y+=uni;
     }
    }
   }
  }
 }

 boolean check(){//このアイコンにマウスが載っているかどうかを判定し返す。
    if (mag(x-mouseX,y-mouseY)<=30){
      return true;
      }else{
      return false;
      }
 }
 
 void state_change(){//スキマの状態変更
  if (state==0){ 
   flag_sukima=true;
  }else if (state==1){
   sukima_p.state=2;
   flag_sukima=false;
  }else{
   state=0;
   flag_sukima=false;
  }
 }

}



void updateRepul(){//斥力の更新
  int count=0;
  for (int j = 0; j<nodeCount;j++){
  // println(j);
   if (nodes[j].exist==true){
    count+=1;
   }
  }
  repul=sqrt(3/count);
}

void loadData() {// データの読み込み
    sukima_p=new Sukima(30,30,false,loadImage("pic_without_chara/sukima.png"),loadImage("pic_without_chara/sukima_in.png"),loadImage("pic_without_chara/sukima_out.png"));//スキマの生成。復数作るかは分からないのでクラスを定義する意義は微妙だけど…
    //String[] lines = loadStrings("キャラの組み合わせ出現数_割合.txt");//ファイルからStringへ
    String[] lines = loadStrings("coupling.txt");//ファイルからStringへ
    String[] names = loadStrings("image_name.txt");//ファイルからStringへ
    String[] ranking = loadStrings("ranking.txt");//ファイルからStringへ
    String[] r_names = loadStrings("real_name.txt");//ファイルからStringへ
    nodeCount=lines.length-1;
    String[] fileName = new Sring[3];
    fileName[0] = "16_16/";
    fileName[2] = "16.png";
    for (int i = 1; i < lines.length; i++) {//一行ごとに。最初の行は名前しか入ってないので無視
        fileName[1]=names[i-1];
        /*if (i%2==0){
         boolean exi=true;
        }else{
         boolean exi=false;
        }*/
        PImage tmpi=loadImage(join(fileName,""));
        //println(join(fileName,""));
        //String [] tokens = splitTokens(lines[i], " (,)");//(の前、,の前、)の前に分ける
        String[] frs = splitTokens(lines[i],"\t");//タブごとに区切る。frsはfrequenciesの略
        int[] rank = splitTokens(ranking[i-1]," ");//空白ごとに区切る。
        //list=frs[1:lines.length];//配列の一部を呼び出すには．．．？
        //int[] rank=[1,2,3];
        if (frs != null && frs.length > 0) {
            float[] tmp = new float[nodeCount];
            for (int j = 1; j < frs.length; j++) {
              tmp[j-1]=frs[j];
            }
            //println(frs[0]);
            nodes[i-1] =new Node(frs[0],tmp,tmpi,true,i-1,rank,r_names[i-1]);
        }
    }

   selectCharacter("チュートリアル");
    tuto=10;
}



void selectCharacter(String g) {//表示するキャラクターの指定、またはチュートリアルモードに入るためのフラグ立て
    //ellipse(100, 100, 200,200);
    i_v_li=20;
    ex_nodeCount=0;
    String[] lines = loadStrings("series.txt");//ファイルからStringへ
    for (int i = 0; i < lines.length; i++) {//一行ごとに。列の最初がグループ名
        String[] ns = splitTokens(lines[i],"\t");//タブごとに区切る。
        if (ns[0]==g){
            for (int k = 0; k < nodeCount; k++){
                Node n = nodes[k];
                n.exist=false;
                for (int j = 1; j < ns.length; j++) {
                 if (ns[j]==n.name){
                  n.exist=true;
                  ex_nodeCount+=1;
                  n.ex_num=ex_nodeCount;
                  x=int(random(width));
                  y=int(random(height));
                 }
                }
            }
        }
    }
    if (g=="チュートリアル"){
        tuto=0;
        un_playable();
    }else if (g=="TIPS1 関係の深さと矢印の向き"){
        tuto=1;
        un_playable();
    }else if (g=="TIPS2 画面上部にあるもの"){
        tuto=2;
        un_playable();
    }else{
        tuto=-1;
        ctrl=1;
        tuto_si=0;
        bor_u=20;
    }
    if (g=="ランダム"){
            ex_nodeCount=0;
            for (int k = 0; k < nodeCount; k++){
                Node n = nodes[k];
                n.exist=false;
                if (random()>0.8){
                  n.exist=true;
                  ex_nodeCount+=1;
                  n.ex_num=ex_nodeCount;
                }
            }

    }
    hueSet();

}

void hueSet(){//アイコンへの色の割り当て
  ex_nodeCount=0;
  for (int j = 0; j<nodeCount;j++){
   if (nodes[j].exist==true){
    ex_nodeCount+=1;
    nodes[j].ex_num=ex_nodeCount;
    }
  }
  for (int j = 0; j<nodeCount;j++){
   if (nodes[j].exist==true){
    nodes[j].hue=255*nodes[j].ex_num/ex_nodeCount;
   }
  }
}

void playable(){//操作できる状態にする関数
     selectCharacter("東方地霊殿");
     tuto=-1;
     ctrl=1;
     bor=20;
     bor_u=20;
     SwiX=440;
}


void un_playable(){//操作できない（チュートリアル）状態にする関数
     ctrl=0;
     tuto_si=0;
     bor_u=20;
     sukima_p.state=0;
     stop=false;
     SwiX=440;
}

void mouseClicked() {//マウスがクリックされたらいつでも実行される関数

 if (tuto==-1){
  if (sukima_p.state==2){//スキマからアイコンを出す処理
   for (int j = 0; j<nodeCount;j++){
    if (nodes[j].exist==false && nodes[j].s_check()==true && nodes[j].s_move==false){
     nodes[j].i_export();
    //nodes[j].o_sx=sukima_p.x;
    //nodes[j].o_sy=sukima_p.y;
    //nodes[j].s_export=true;
    //nodes[j].exist=true;
    //hueSet();
    }
   }
  }


  if (sukima_p.state==1){//スキマへクリックでアイコンを入れる処理
   for (int j = 0; j<nodeCount;j++){
    if (nodes[j].exist==true && nodes[j].check()==true){
     nodes[j].s_inport=true;
    }
   }
  }


  if (sukima_p.check()==true){//スキマの状態の切り替え
   sukima_p.state_change();
  }


  if (mag(c_x-mouseX,c_y-mouseY)<=c_b){//時計の状態切り替え
   if (stop==false){
    stop=true;
   }else{
    stop=false;
   }
  }
 }
      /*for (int i = 0; i < nodeCount; i++){//ページへのリンク
        if (pick_num == i && nodes[i].exist==true){
          if(mouseX>400 && mouseY>400){
           link("http://www.nicovideo.jp/search/%E3%81%95%E3%81%A8%E3%82%8A%E3%80%80%E3%81%93%E3%81%84%E3%81%97?track=nicomy_search_keyword", "_new");
          }
        }
      }*/


 if (ctrl==0 && (tuto==0 || tuto==1 || tuto==2)){//チュートリアルを読み進める
   //image(sukima,10,10);
   tuto_si+=1;
   f_tu=0;
 }

 if (f_que==0 && tuto==10){//「見る！」を選択
   tuto=0;
   ctrl=0;
   tuto_si=0;
 }

 if (f_que==1 && tuto==10){//「じゃあいいです」を選択
   playable();
 }

}

void keyReleased() {//キー入力によるスキマか時計の状態切り替え
 if (ctrl==1){
  if (key=='t' && sukima_p.state!=2){
    if (stop==false){
     stop=true;
    }else{
     stop=false;
    }
  }
 
  if (key=='s'){
   sukima_p.state_change();
  }
 }
}



void tutorial(){//チュートリアルを表示する関数。
  f_q_ti+=2;
  if (tuto_si<7){
   bor_u=constrain(f_q_ti,20, height/4);
  }
  switch(tuto_si) {
    case 0:
     telop(['これは、東方Projectのキャラクター達の人間関係を可視化するツールです。']);
     break;
    case 1:
     nodes[0].icon_eff ();
     nodes[1].icon_eff ();
     x_c=(width/2+nodes[0].x+nodes[1].x)/3;
     y_c=(height/2+nodes[0].y+nodes[1].y)/3;
     arrow(x_c,y_c,x_c*0.3+nodes[0].x*0.7,y_c*0.3+nodes[0].y*0.7);
     arrow(x_c,y_c,x_c*0.3+nodes[1].x*0.7,y_c*0.3+nodes[1].y*0.7);
     p_check(0.2*width/2+0.8*x_c,0.2*height/2+0.8*y_c);
     telop(['関係の深いキャラのアイコン同士が近くに来るようになっています。','例えば、この場合は「霊夢」と「魔理沙」が近くに来ています。']);
     break;
    case 2:
     float[] arrow_pos1=pos_Arrow(nodes[0].x,nodes[0].y,nodes[1].x,nodes[1].y,12,0.5);
     float[] arrow_pos2=pos_Arrow(nodes[1].x,nodes[1].y,nodes[0].x,nodes[0].y,12,0.5);
     x_c=(width/2+nodes[0].x+nodes[1].x)/3;
     y_c=(height/2+nodes[0].y+nodes[1].y)/3;
     arrow(x_c,y_c,arrow_pos1[0],arrow_pos1[1]);
     arrow(x_c,y_c,arrow_pos2[0],arrow_pos2[1]);
     p_check(0.2*width/2+0.8*x_c,0.2*height/2+0.8*y_c);
     telop(['また、キャラの間にある線や矢印も、関係が深いほど太く大きくなっています。','この場合、やはり「霊夢」と「魔理沙」の間にある矢印が大きいですね。']);
     break;
    case 3:
     telop(['操作方法について、マウスで全ての操作を行います。','アイコンを左ボタンでドラッグすると、アイコンを任意の位置へ動かせます。']);
     break;
    case 4:
     nodes[0].icon_eff ();
     nodes[0].icon_arc();
     arrow(2*width/5,height/2,4*width/7,height/3);
     p_check(2*width/5,height/2);
     telop(['また、ドラッグしているアイコンのキャラについて、右上に円グラフが出ます。','この場合、霊夢と関係の深いキャラほど円グラフを占める割合が大きくなります。']);
//     telop(['アイコンの速度には慣性がついているので、速くドラッグしているときにボタンから指を離すと、','アイコンが勢いよく飛んでいって面白いです。']);
     break;
    case 5:
     telop(['ウィンドウ下部にある選択項目（プルダウン）で、表示するキャラを決めます。','選択した後に右の「作品設定」ボタンをクリックすると、','選択した作品に登場するキャラのみが表示されます。']);
     float sin_c=(frameCount/3)%(2*PI);
     float y_s=7*sin(sin_c);//倍率
     arrow(100,y_s+540,100,y_s+590);
     break;
    case 6:
     telop(['基本的な説明は以上です。このチュートリアルは作品設定から「チュートリアル」を','選ぶことで見られます。また、「TIPS」による補足説明もできます。']);
     float sin_c=(frameCount/3)%(2*PI);
     float y_s=7*sin(sin_c);//倍率
     arrow(100,y_s+520,100,y_s+570);
     break;
    case 7:
     telop(['とはいえ、最初はアイコンを動かしてみましょう。','私の好きな地霊殿のキャラを表示します。では！']);
     break;
    case 8:
     playable();
     break;


  }
}

void tips1(){//tips1(関係の深さと矢印の向き)を表示する関数。
  f_q_ti+=2;
  if (tuto_si<7){
   bor_u=constrain(f_q_ti,20, height/4); 
  }
  switch(tuto_si) {
    case 0:
     SwiX=350;
     telop(['アイコン同士の位置関係を決める「関係の深さ」。','この値は、作者が調節しているわけではありません。']);
     break;
    case 1:
     telop(['Twitter上で、一つのつぶやきに東方キャラの名前が二種類以上含まれる場合、その','キャラ達の間で関係の深さが増していきます。']);
     break;
    case 2:
     nodes[3].icon_eff ();
     nodes[53].icon_eff ();
     telop(['矢印の動く向きについて、大妖精とチルノを例に説明します。']);
     break;
    case 3:
     float[] arrow_pos1=pos_Arrow(nodes[3].x,nodes[3].y,nodes[53].x,nodes[53].y,12,0.5);
     float[] arrow_pos2=pos_Arrow(nodes[53].x,nodes[53].y,nodes[3].x,nodes[3].y,12,0.5);
     x_c=(width/2+nodes[3].x+nodes[53].x)/3;
     y_c=(height/2+nodes[3].y+nodes[53].y)/3;
     arrow(x_c,y_c,arrow_pos1[0],arrow_pos1[1]);
     arrow(x_c,y_c,arrow_pos2[0],arrow_pos2[1]);
     p_check(0.2*width/2+0.8*x_c,0.2*height/2+0.8*y_c);
     telop(['大妖精からチルノに向かっては大きい矢印、チルノから大妖精に向かっては小さな','矢印が出ていますね。']);
     break;
    case 4:
     float[] arrow_pos2=pos_Arrow(nodes[53].x,nodes[53].y,nodes[3].x,nodes[3].y,12,0.5);
     x_c=(width/2+nodes[3].x+nodes[53].x)/3;
     y_c=(height/2+nodes[3].y+nodes[53].y)/3;
     arrow(x_c,y_c,arrow_pos2[0],arrow_pos2[1]);
     p_check(0.2*width/2+0.8*x_c,0.2*height/2+0.8*y_c);
     telop(['大妖精からチルノに向かう矢印の大きさは、「大妖精」を含むつぶやきのうち、','「チルノ」と「大妖精」が同時に出現するものの割合です。']);
     break;
    case 5:
     float[] arrow_pos1=pos_Arrow(nodes[3].x,nodes[3].y,nodes[53].x,nodes[53].y,12,0.5);
     x_c=(width/2+nodes[3].x+nodes[53].x)/3;
     y_c=(height/2+nodes[3].y+nodes[53].y)/3;
     arrow(x_c,y_c,arrow_pos1[0],arrow_pos1[1]);
     p_check(0.2*width/2+0.8*x_c,0.2*height/2+0.8*y_c);
     telop(['逆に、チルノから大妖精に向かう矢印の大きさは、「チルノ」を含むつぶやきのうち、','「チルノ」と「大妖精」が同時に出現するものの割合です。']);
     break;
    case 6:
     telop(['わかりやすく言うと、「大妖精にとって、チルノは唯一無二の親友。','でも、チルノにとっては、大妖精は数ある友達の一人にすぎない」','ということです。']);
     break;
    case 7:
     telop(['……切ないですね。']);
     break;
    case 8:
     playable();
     break;
  }
}

void tips2(){//tips2(画面上部にあるもの)を表示する関数。
  f_q_ti+=2;
  if (tuto_si<7){
   bor_u=constrain(f_q_ti,20, height/4); 
  }
  switch(tuto_si) {
    case 0:
     float x_c=width/2;
     float y_c=height/4;
     telop(['画面上部にある三つのアイコンについて説明します。']);
     arrow(x_c,y_c,sukima_p.x,sukima_p.y);
     arrow(x_c,y_c,c_x,c_y);
     arrow(x_c,y_c,SwiX,height/10);
     p_check(x_c*1.2,y_c);
     break;
    case 1:
     telop(['左にあるこれはスキマです。キャラのアイコンを格納できます。']);
     arrow(sukima_p.x,sukima_p.y+height/5,sukima_p.x,sukima_p.y);
     p_check(sukima_p.x+width/10,sukima_p.y+height/5);
     break;
    case 2:
     telop(['スキマをクリックすると、このように黒い矢印が入っていくアイコンに変わります。']);
     sukima_p.state=1;
     arrow(sukima_p.x,sukima_p.y+height/5,sukima_p.x,sukima_p.y);
     p_check(sukima_p.x+width/10,sukima_p.y+height/5);
     break;
    case 3:
     telop(['この状態でキャラのアイコンをクリックすると、','アイコンがスキマに吸い込まれて消えます。スキマ送りです。']);
     if (f_tu==0){
      nodes[0].s_inport=true;
     }else if(f_tu==30){
      nodes[1].s_inport=true;
     }else if(f_tu==60){
      nodes[11].s_inport=true;
     }
     float x_c=width/2;
     float y_c=height/2;
     if (f_tu>=0 && nodes[0].exist==true){
      arrow(x_c,y_c,nodes[0].x,nodes[0].y);
     }else if(f_tu>=10 && nodes[1].exist==true){
      arrow(x_c,y_c,nodes[1].x,nodes[1].y);
     }else if(f_tu>=40 && nodes[11].exist==true){
      arrow(x_c,y_c,nodes[11].x,nodes[11].y);
     }
     p_check(x_c+width/10,y_c);
     break;
    case 4:
     telop(['またスキマをクリックすると、今度は黒い矢印が出て行くアイコンに変わります。']);
     sukima_p.state=2;
     arrow(sukima_p.x,sukima_p.y+height/5,sukima_p.x,sukima_p.y);
     p_check(sukima_p.x+width/10,sukima_p.y+height/5);
     break;
    case 5:
     telop(['今、画面に表示されている大きなキャラのアイコンは、','スキマ内に格納されているアイコンです。']);
     break;
    case 6:
     telop(['この状態で大きなキャラのアイコンをクリックすると,','アイコンがスキマから外に出て行きます。']);
     if (f_tu==0){
      nodes[0].i_export();
     }else if(f_tu==50){
      nodes[1].i_export();
     }else if(f_tu==100){
      nodes[11].i_export();
     }
     float x_c=width/2;
     float y_c=height/7;
     if (f_tu>=0 && f_tu<50){
      if (nodes[0].exist==false){
       arrow(x_c,y_c,nodes[0].sx,nodes[0].sy);
      }else{
       arrow(x_c,y_c,nodes[0].x,nodes[0].y);
      }
     }else if(f_tu>=50 && f_tu<100){
      if (nodes[0].exist==false){
       arrow(x_c,y_c,nodes[1].sx,nodes[1].sy);
      }else{
       arrow(x_c,y_c,nodes[1].x,nodes[1].y);
      }
     }else{
      if(nodes[11].exist==false){
       arrow(x_c,y_c,nodes[11].sx,nodes[11].sy);
      }else{
       arrow(x_c,y_c,nodes[11].x,nodes[11].y);
      }
     }
     p_check(x_c+width/10,y_c);
     break;
    case 7:
     telop(['ここからスキマをクリックすると、スキマのアイコンが最初の状態に戻ります。','スキマをクリックする操作は、「s」キーでも代用できます。']);
     sukima_p.state=0;
     arrow(sukima_p.x,sukima_p.y+height/5,sukima_p.x,sukima_p.y);
     p_check(sukima_p.x+width/10,sukima_p.y+height/5);
     break;
    case 8:
     telop(['画面上部やや左にあるこれは、咲夜さんの時計です。','時間を止め、キャラのアイコンの動きを止められます。']);
     arrow(c_x,c_y+height/5,c_x,c_y);
     p_check(c_x+width/10,c_y+height/5);
     break;
    case 9:
     telop(['咲夜さんの時計をクリックすると、こうなります。']);
     stop=true;
     break;
    case 10:
     telop(['また時計をクリックすると、そして時は動き出す...','（元の状態に戻ります）']);
     stop=false;
     break;
    case 11:
     telop(['「キャラのアイコンが動いて鬱陶しい！」という方は使ってみて下さい。','時計をクリックする操作は、「t」キーでも代用できます。']);
     break;
    case 12:
     telop(['画面上部右にあるこれは、矢印を表示する量を決めるバーです。']);
     arrow(SwiX,height/4,SwiX,height/10);
     p_check(SwiX+width/10,height/4);
     break;
    case 13:
     telop(['バー左にドラッグすると、キャラのアイコンの間にある矢印が、','細いものも表示されるようになります。']);
     arrow(SwiX,height/4,SwiX,height/10);
     p_check(SwiX+width/10,height/4);
     SwiX=constrain(SwiX-5,230,530);
     fill(170);
     stroke(0,0,0,255);
     rect(SwiX-10,height*0.05-20,20,40);
     break;
    case 14:
     telop(['右にドラッグすると、太い矢印しか表示されなくなります。']);
     arrow(SwiX,height/4,SwiX,height/10);
     p_check(SwiX+width/10,height/4);
     SwiX=constrain(SwiX+5,230,530);
     fill(170);
     stroke(0,0,0,255);
     rect(SwiX-10,height*0.05-20,20,40);
     break;
    case 15:
     telop(['「あまり関係が深くないキャラ同士のことも知りたい！」という方は、','左にバーを動かすと良いかと思います。']);
     SwiX=450;
     break;
    case 16:
     playable();
     break;
  }
}

void telop(string[] s) {// テロップの表示。40文字ごとに自動改行したいが、pythonと違ってめんどいのでやめる
    strokeWeight (0.1);
    fill(0,0,0,128);
    stroke(0,0,0,0);
    //float w = textWidth(full_name);
    //float b_x = constrain(3*width/5-w, 0, width/2); 
    int t_x=20;//ウィンドウがどれだけ左右の端から離れてるか
    int t_y=20;//ウィンドウがどれだけ下の端から離れてるか
    int w_y=100;//ウィンドウの縦の長さ
    rect(t_x,height-t_y-w_y,width-t_x*2,w_y);
    fill(255,0,255,255);
    for (int i = 0; i <= s.length; i++) {
     textFont("SansSerif", t_s);
     float w = textWidth(s[i]);
     text(s[i], (width)/12,i*(t_s+2)+height-w_y);
    }
    float sin_c=(frameCount/3)%(2*PI);
    float y_s=7*sin(sin_c);//倍率
    int tr_x=width*9/10;
    float tr_y=height*9/10+y_s;
    int tr_s=15;
    triangle(tr_x,tr_y,tr_x+tr_s,tr_y-tr_s,tr_x-tr_s,tr_y-tr_s);

    //rect(tr_x,tr_y,500,500,400,600);
}

void arrow(float s_x,float s_y,float arrow_x,float arrow_y){//チュートリアル用の矢印を表示する関数
        fill(40,128,255);
        stroke(40,255,255);
        float ang=atan2(arrow_y-s_y,arrow_x-s_x);
        ang_no=PI/2+ang;
        float sl_x=cos(ang_no)*12;//slはスリップhue
        float sl_y=sin(ang_no)*12;
        float tri_ang=9*PI/10;
        int tri_mag=16;//三角形の大きさ
        strokeWeight(0.5);
        triangle(arrow_x, arrow_y, arrow_x+cos(ang+tri_ang)*tri_mag, arrow_y+sin(ang+tri_ang)*tri_mag, arrow_x+cos(ang-tri_ang)*tri_mag, arrow_y+sin(ang-tri_ang)*tri_mag);
        strokeWeight(2);
        line(s_x,s_y,arrow_x,arrow_y);
}

void p_check(float x,float y){//"check!"と表示する関数
     textFont("SansSerif", 36);
     float w = textWidth('Check!');
     text('Check!', x-w/2,y+36/2);
}

float[] pos_Arrow(float s_x,float s_y,float e_x,float e_y,float rad,float rat){//二つのアイコン間に引く線に必要な座標の計算をし、値として返す
     float ang=atan2(e_y-s_y,e_x-s_x);
     ang_no=PI/2+ang;
     float sl_x=cos(ang_no)*rad;//slはスリップ。radは線がアイコン中心からどれだけ離れてるか
     float sl_y=sin(ang_no)*rad;
     float arrow_x=(e_x-s_x)*rat+s_x+sl_x;//ratはアイコンを結ぶ線のうち、どちらのアイコンに近いか。0から1の間で変動
     float arrow_y=(e_y-s_y)*rat+s_y+sl_y;
     return [arrow_x,arrow_y];
}

void f_question(){

     int a=0;
     fill(0,0,0,128);
     stroke(0,0,255,0);
     int t_x=20;//ウィンドウがどれだけ左右の端から離れてるか
     int t_y=20;//ウィンドウがどれだけ下の端から離れてるか
     int w_y=100;//ウィンドウの縦の長さ
     rect(t_x,t_y,width-t_x*2,w_y+t_y);
     t_x=150;
     t_y=365;
     rect(t_x,t_y,width-t_x*1.5,w_y);


     strokeWeight (2);
     int tr_x=208;
     int tr_y=110;
     int tr_s=5;
     fill(30,70,255,255);//透明度を0にすると不透明になるバグあり
     stroke(0,0,0,255);
     textFont("SansSerif", 22);
     float w = textWidth('少し長くなるが良いか？');
     //ellipse(3*width/5, 110, w*1.3, 36);
     rect(0.414*width, 95, w, 36);
     triangle(tr_x,tr_y,tr_x+tr_s*8,tr_y+tr_s,tr_x+tr_s*8,tr_y-tr_s);
     stroke(0,0,0,0);
     rect(245, 107, 5, 7);
     fill(0,0,0);
     text('少し長くなるが良いか？', 0.414*width,120);
     image(nodes[81].dot,170,100,32,32);

     fill(0,0,255);
     textFont("SansSerif", 42);
     float w = textWidth('チュートリアルを見ますか？');
     text('チュートリアルを見ますか？', width/2-w/2,70);

     //fill(0,0,0,0);
     //stroke(0,0,255,255);
     //fill(0,0,0,0);



     t_s_tmp=30;//ここだけのテキストサイズ
     fill(0,0,255,255);
     textFont("SansSerif", t_s_tmp);
     y_yes=400;
     text('見る！', width/3,y_yes);

     textFont("SansSerif", t_s_tmp);
     y_no=450;
     text('じゃあいいです（見ない）', width/3,y_no);

     if (t_x<=mouseX && mouseX<=width-t_x && y_yes>=mouseY && mouseY>=y_yes-t_s_tmp){
       cursor(t_x+30,y_yes-t_s_tmp*0.75/2);
       fill(0,0,0,0);
       stroke(255,0,255,255);
       strokeWeight (2);
       rect(t_x,y_yes-t_s_tmp,width-t_x*1.5,t_s_tmp*1.25);
       f_que=0;
     }else if (t_x<=mouseX && mouseX<=width-t_x && y_no>=mouseY && mouseY>=y_no-t_s_tmp){
       cursor(t_x+30,y_no-t_s_tmp*0.75/2);
       fill(0,0,0,0);
       stroke(255,0,255,255);
       strokeWeight (2);
       rect(t_x,y_no-t_s_tmp,width-t_x*1.5,t_s_tmp*1.25);
       f_que=1;
     }else{
     f_que=-1;
     }

     textFont("SansSerif", t_s);
     fill(0,0,0);
}

void show_clock(){//時計アイコンの表示
 image(clock,c_x-c_b,c_y-c_b,c_b*2,c_b*2);

 translate(c_x,c_y);
 rotate((f_count/20)%(2*PI));
 image(clock_pin,0,-5,c_b,10);
 rotate(-1*((f_count/20)%(2*PI)));
 translate(-c_x,-c_y);
}

void threshold(){//表示する線のしきい値を設定
 colorMode(HSB);

 fill(0,0,0,255);
 stroke(0,0,0,255);

 font = createFont("SansSerif", t_s*1.2);
 text('Few', width*0.86, height*0.025);
 text('Many',width*0.35,height*0.025);

 stroke(0);
 strokeWeight(0.5);
 fill(0,0,255,192);
 line (230,height*0.05,530,height*0.05);
 for (int i=0;i<11;i++){
  if (i==0 || i==10){
   line (230+i*30,0,230+i*30,height*0.10);
  }else{
   line (230+i*30,height*0.02,230+i*30,height*0.08);
  }
 }
 rect(SwiX-10,height*0.05-20,20,40);
 if (ctrl==1 && mousePressed == true) {
   if (anc_f == -2 ){
    SwiX=constrain(mouseX,230,530);
    fill(0,0,128,192);
    rect(SwiX-10,height*0.05-20,20,40);
   }else{
    if (pmousePressed == false){
     if (mouseY<=height*0.05+20&&mouseY>=height*0.05-20&&mouseX<=SwiX+10&&mouseX>=SwiX-10){
      anc_f=-2;
     }
    }
   }
 }else{
 //if (mousePressed == false) {
   anc_f=0;
 }
}

void cursor(float x,float y){//三角形のカーソルを表示する関数
    strokeWeight (0.1);//0にすると無視される
    float cos_c=(frameCount/3)%(2*PI);
    float x_s=7*cos(cos_c);//倍率
    int tr_x=x+x_s;
    float tr_y=y;
    int tr_s=18;
    triangle(tr_x,tr_y,tr_x-tr_s,tr_y+tr_s,tr_x-tr_s,tr_y-tr_s);
}

void draw() {//毎フレーム実行される関数
  background(255);
  updateRepul();
  for (int q = 0; q<nodeCount;q++){//ループがうまくいってなかった。原因はノード番号が存在しないノードを指すから
   nodes[q].s_force();//宣言してない関数を使うと原因を出さずに動かなくなる
   nodes[q].force();
   nodes[q].wall();
  }


  for (int j = 0; j<nodeCount;j++){
  // println(j);
   if (nodes[j].exist==true){
    if (stop==false || flag==j){
      nodes[j].update();
    }
    nodes[j].show_cone();//この関数のせいでフリーズするわけではない
    nodes[j].show();
   }else{
    nodes[j].s_update();
   }
  }

  threshold();


  if (ctrl==1 && sukima_p.state==0){
   if (mousePressed == true){
      if (pmousePressed == false){
        for (int i = 0; i < nodeCount; i++){
          if (nodes[i].check () == true){// 各頂点のアイコンにマウスが載っているかどうかを判定し返す。
            flag=i; 
            pick_num=i;
          }
        }
      }
      for (int i = 0; i < nodeCount; i++){
        if (flag == i){// 掴んでいるアイコンに対する操作
          nodes[i].pos ();
          nodes[i].icon_eff ();
          nodes[i].icon_arc ();
        }
      }
   }else if (flag!=-1){
      if (nodes[flag].check_sukima()==true){
        nodes[flag].exist=false;
        flag_sukima=false;
        hueSet();
        sukima_p.anim_count=0;
      }
      flag=-1;
   }
  }


  pmousePressed=mousePressed;

  if (icon_f==true){
   icon_fr+=1;
  }else{
   icon_fr=0;
  }
  icon_f=false;

  if (sukima_p.state==2){
   stop=false;
   sukima_p.show_cont();
  }

  if (sukima_p.state==2){
   sukima_p.show_out();
  }else if (sukima_p.state==1){
   sukima_p.show_in();
  }else{
   sukima_p.show();
  }

  if(flag_sukima==true){
   sukima_p.state=1;
  }

      for (int i = 0; i < nodeCount; i++){
        /*if (pick_num == i && nodes[i].exist==true){
          nodes[i].icon_arc ();
        }*/
        if (nodes[i].exist==true && nodes[i].check_sukima()==true && nodes[i].s_inport==true){
          nodes[i].exist=false;
          nodes[i].s_inport=false;
          hueSet();
          sukima_p.anim_count=0;
        }
        if (nodes[i].exist==false && nodes[i].check_sukima_inc()==true && nodes[i].s_export==true){
          nodes[i].x=sukima_p.x+random();
          nodes[i].y=sukima_p.y+random();
          nodes[i].exist=true;
          nodes[i].s_export=false;
          hueSet();
        }
      }

 if (stop==false){
  f_count+=1;
  i_v_li+=1;
 }
 

 if (ctrl==1){
  if (sukima_p.state!=2){
   if (mag(c_x-mouseX,c_y-mouseY)<=c_b){//時計アイコンにマウスが乗ってたらエフェクト表示
    fill(100,50);
    if (mousePressed==true){
     fill(100,100);
    }
    stroke(0,0,0,0);
    ellipse(c_x,c_y,c_b*2,c_b*2);
   }
  
   if ((keyPressed == true) && (key == 't')) {//'t'キーが押されたら時計エフェクト表示
    fill(100,100);
    stroke(0,0,0,0);
    ellipse(c_x,c_y,c_b*2,c_b*2);
   }
  }
  
  if (sukima_p.check()==true){//スキマアイコンにマウスが乗ってたらエフェクト表示
   fill(100,50);
   if (mousePressed==true){
    fill(100,100);
   }
   stroke(0,0,0,0);
   ellipse(sukima_p.x,sukima_p.y,60,60);
  }
  
  if ((keyPressed == true) && (key == 's')) {//'s'キーが押されたらスキマエフェクト表示
   fill(100,100);
   stroke(0,0,0,0);
   ellipse(sukima_p.x,sukima_p.y,60,60);
  }
 }


 show_clock();
 
 if (tuto!=-1){
  fill(0,0,0,32);
  stroke(0,0,0,0);
  rect(0,0,width,height);

  if (tuto==0){
    tutorial();
  }

  if (tuto==1){
    tips1();
  }

  if (tuto==2){
    tips2();
  }

  if (tuto==10){
    f_question();
  }
 }

 sukima_p.anim_count+=1;
 f_tu+=1;

}
