#!/usr/bin/python
# -*- coding: utf-8 -*-
import urllib
import urllib2
import json
import time
import os
import datetime
import math
import string
import sqlite3
import sys
import glob
import gzip
#東方キャラについてのツイートをDBに入れる。ツイートのIDをユニーク値とするが、うまく機能してない気がする。
#botのツイートは除外する。理由は、botは1つのアカウントで大量の発言を行い、キャラ名の共起頻度に過度な影響を与えると考えられるため。

con=sqlite3.connect("th_2011.db")

con.execute("BEGIN TRANSACTION;")

sql = u"""
CREATE VIRTUAL TABLE ツイート USING fts3(
  chara varchar(30),
  tweet_ID varchar(32) PRIMARY KEY,
  TEXT varchar(300),
  time varchar(31),
  user_name varchar(20),
  user_ID varchar(32)
);
"""


con.execute(sql)

dt = datetime.datetime.fromtimestamp(time.time())
name='キャラ一覧_本名だけ'
f=open('/home/kitabayashi/data/ex_th/'+name+'.txt')
query=f.readlines()
que=[]

c_n=0#普通のツイート数
c_b=0#botのツイート数

for j in range(0,len(query)):
 que.append(unicode(query[j].strip('\n'),"utf-8"))

f.close()


fb=open('/home/kitabayashi/corpus/bot_ID/botのID一覧_12_13.txt')
b_ID=fb.readlines()
for j in range(0,len(b_ID)):
 b_ID[j]=b_ID[j].strip('\n').upper()

fb.close()

ch=""#ツイートに出てくる全てのキャラ

#dics[0]['a']=''
#print str(len(dics[0])/float(ap[0]))

for j in range(0,len(que)):

#for j in range(0,2):
 dir="/home/kitabayashi/data/ex_th/th/"+que[j]+"/"
 if os.path.isdir(dir)==True:
   list = os.listdir(dir)
   print que[j]+u'成功'
   for file in list:
     #print file
     f=open(dir+file)#一文字目が<でないなら（<ならばエラーファイル）
     if len(f.read())!=0:
      f.close()
      f=open(dir+file)
      if f.read()[0]=='{':
       f.close()
       f=open(dir+file)
       de=json.load(f)
       if de.has_key("results"):
        f.close()
        f=open(dir+file)
        de=json.load(f)
        dec=de["results"]
      #length+=len(dec)#ツイートの数を累計
        for cnt2 in range(0,len(dec)):#保存内容の本文を調査。
       #print cnt2
           if (dec[cnt2]["from_user"].upper() in b_ID) == False:
            c_n+=1
            ch=""
            for o in range(0,len(que)):
             if (dec[cnt2]["text"].find(que[o])!=-1):
             #if (dec[cnt2]["text"].encode("utf-8").find(query[o])==-1):
              ch+=(que[o]+u" ")
            #if (dec[cnt2]["text"].encode("utf-8").find('霊夢')!=-1):
            # ch+=(unicode('霊夢',"utf-8")+u" ")
            sql=u"insert into ツイート values (?,?,?,?,?,?)"
            #print dec[cnt2]["text"]
            #print ch
            try:
              con.execute(sql,(ch,dec[cnt2]["id"],dec[cnt2]["text"],dec[cnt2]["created_at"],dec[cnt2]["from_user"],dec[cnt2]["from_user_id"]))
            #chara=que[j].encode("utf-8")
            #TEXT=dec[cnt2]["text"].encode("utf-8")
            #time=dec[cnt2]["created_at"].encode("utf-8")
            #from_user=dec[cnt2]["from_user"].encode("utf-8")
            #con.execute(sql,(chara,dec[cnt2]["id"],TEXT,time,from_user,dec[cnt2]["from_user_id"]))#stringはユニコードに変換すること
            #con.execute(sql,(u'test',u'test',u'test',u'test',u'test',u'test'))
            except sqlite3.IntegrityError:
              c_n-=1
            #con.execute(sql,(u'test',c_n,u'test',u'test',u'test',u'test'))
           else:
             c_b+=1
   con.commit()
   con.execute("VACUUM;")
            #print dec[cnt2]["from_user"]
         #tdb[str(dec[cnt2]["id"])]={"text":dec[cnt2]["text"].encode('utf-8'),"time":dec[cnt2]["created_at"]}


con.commit()
con.close()

print "普通のツイートは"+str(c_n)
print "botのツイートは"+str(c_b)

print time.clock()
